;**********************************************************************
;     2014.04.17    Completed;2014.05.19                                                           *
;    Filename:        ekeym5t.asm            *
;    Date:  2014.04.17                                                          *
;    File Version:                                                *
;    2014.05.13@ mark1  mark2Aspace1 space2 Ԋu΂                                                             *
;    Author:                                                        *
;    Company:                                                         *
;       Ref  ekey4.asmAMPLABɈڐAB
;_AZ_@\ǉB@HH@\eneble<RA4=H>;;disable<RA4=L>, RA0800Hzo͒ǉ
;**********************************************************************
;                                                                     *
;    Files required: P16F84A.INC                                      *
;                                                                     *
;		NbN	4MHz X'tal
;
;**********************************************************************
;       64*8bit EEPROM ް؂address
;     0  1   2   3   4   5   6   7   8   9   a   b   c   d   e  f            
; 0   -   IvV [  48   -   -   -   
;10   -   IvV [  48   -       -
;20   -   IvV [  48   -
;30   -   IvV [  48   -       -
;
;   ref p121 of CQ March 1998   JR7RAR Gꎁ̃ACfA
;			MORSEcode A=01000010b 2_\(010b)  gc[i01j
;			MORSEcode Q=11010100b 4_\(100b)  c[c[gc[i1101j

;	sATC
;

;	RB0(06)				SW for 'TEST
;	RB1(07)				SW for STAMP
;	RB2(08)				SW for OPTION
;	RB3(09)				SW for Write_OPTION
;	RB4(10)				elekey :dash 
;	RB5(11)				elekey :dot
;	RB6(12)				SW for DE
;	RB7(13)				SW for CQ
;	RA0(17)				side tone out
;	RA1(18)				o;Key out
;	RA2(01)				C=1000pF
;	RA3(02)				VR=100k
;	RA4(03)				none
;
;**********************************************************************
    list      p=16F84A             ; list directive to define processor
    #include <p16F84a.inc>         ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

    __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The lables following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.

#define		BZ   	PORTA,0		;;Buzzer

;***** VARIABLE DEFINITIONS

wait_cn		EQU	H'0C'
wait_cn2	EQU	H'0D'
cs			EQU	H'0E'
cn			EQU	H'0F'
;   --------------- adress 10&H 
speed		EQU	H'10'	;20<elekey speed<150 /when speed=50,Mark=50msec(WPM=10),
opt			EQU	H'11'	;if opt.0=1 ,option_bun save mode
cwcode		EQU	H'12'	;MORSEcode A=01000010b 2L(010b)  gc[i01j
length		EQU	H'13'	;PMORSEcodeɊ܂܂钷_AZ_̍v;o
pos			EQU	H'14'
sum			EQU	H'15'	;PMORSEcodeɊ܂܂钷_AZ_̍v;save
mk			EQU	H'16'	;codeodotmk=0,dashmk=1 Ƃ
N			EQU	H'17'	
d8			EQU	H'18'	;MORSEcodeL^			
ct			EQU	H'19'	
cu			EQU	H'1a'	
Bugauto		EQU	H'1b'	;if Bugauto.7=1, then dash dot auto. else normal Bug 
memo		EQU	H'1c'	;momory for dot duirng dash or dash during dot
timespace	EQU	H'1d'	;timespace=150 or 138 (Mark:space=100:92) 
HH0			EQU	H'1e'	;HH0=B'00000111'
HH1			EQU	H'1f'	;HH1=B'00000001' in case H=6, HH1=B'00000011'case H=7,  HH1=B'00000111'case H=8, 
;    ------------- adress 20&H
opbun0		EQU	H'20'	;option48;K20hԒn
opbun1		EQU	H'21'
opbun2		EQU	H'22'
opbun3		EQU	H'23'
opbun4		EQU	H'24'
opbun5		EQU	H'25'
opbun6		EQU	H'26'
opbun7		EQU	H'27'
opbun8		EQU	H'28'
opbun9		EQU	H'29'
opbun10		EQU	H'2a'
opbun11		EQU	H'2b'
opbun12		EQU	H'2c'
opbun13		EQU	H'2d'
opbun14		EQU	H'2e'
opbun15		EQU	H'2f'
;    ------------- adress 30&H
opbun16		EQU	H'30'
opbun17		EQU	H'31'
opbun18		EQU	H'32'
opbun19		EQU	H'33'
opbun20		EQU	H'34'
opbun21		EQU	H'35'
opbun22		EQU	H'36'
opbun23		EQU	H'37'
opbun24		EQU	H'38'
opbun25		EQU	H'39'
opbun26		EQU	H'3a'
opbun27		EQU	H'3b'
opbun28		EQU	H'3c'
opbun29		EQU	H'3d'
opbun30		EQU	H'3e'
opbun31		EQU	H'3f'
;    ------------- adress 40&H
opbun32		EQU	H'40'
opbun33		EQU	H'41'
opbun34		EQU	H'42'
opbun35		EQU	H'43'
opbun36		EQU	H'44'
opbun37		EQU	H'45'
opbun38		EQU	H'46'
opbun39		EQU	H'47'
opbun40		EQU	H'48'
opbun41		EQU	H'49'
opbun42		EQU	H'4a'
opbun43		EQU	H'4b'
opbun44		EQU	H'4c'
opbun45		EQU	H'4d'
opbun46		EQU	H'4e'
opbun47		EQU	H'4f'

;**********************************************************************
	ORG     0x000             ; processor reset vector
	goto    start              ; go to beginning of program

	ORG     0x004             ; interrupt vector location
; remaining code goes here


;----------------------------------------------------------------------------

;Ql		retlw	57h	;poi=08h/letr=2eh;"."
;		retlw	H'95'	;poi=09h/letr=2fh;"/"
;		retlw	H'fd'	;poi=0ah/letr=30h;"0" 	letr͉t\̏ꍇ̃R[h
;		retlw	H'7d'	;poi=0bh/letr=31h;"1"  	Ekeył́Asgp
;		retlw	H'3d'	;poi=0ch/letr=32h;"2" 

;		retlw	H'1d'	;poi=0dh/letr=33h;"3" 
;		retlw	H'0d'	;poi=0eh/letr=34h;"4"
;		retlw	H'05'	;poi=0fh/letr=35h;"5"

;		retlw	H'85'	;poi=10h/letr=36h;"6" 
;		retlw	H'c5'	;poi=11h/letr=37h;"7"	
;		retlw	H'e5'	;poi=12h/letr=38h;"8" 

;		retlw	H'f5'	;poi=13h/letr=39h;"9"
;		retlw	H'06'	;poi=14h/letr=3ah;"HH=[:]ŕԂ"
;		retlw	H'7e'	;poi=15hletr=3bh;[;]
;		retlw	H'b5'	;poi=16h/letr=3ch;"<"

;		retlw	H'8d'	;poi=17h/letr=3dh;"="BT
;		retlw	H'b7'	;poi=18h/letr=3eh;">"
;		retlw	H'36'	;poi=19h/letr=3fh;"?"
;		retlw	H'17'	;poi=1ah/letr=40h;"VA"=[@]ŕԂ"
;		retlw	H'42'	;poi=1bh/letr=41h;"A"
;		retlw	H'84'	;poi=1ch/letr=42h;"B"
;		retlw	H'a4'	;poi=1dh/letr=43h;"C"	

;		retlw	83h	;poi=1eh/letr=44h;"D"
;		retlw	01h	;poi=1fh/letr=45h;"E"
;		retlw	24h	;poi=20h/letr=46h;"F"
			
;		retlw	H'c3'	;poi=21h/letr=47h;"G"
;		retlw	H'04'	;poi=22h/letr=48h;"H"
;		retlw	H'02'	;poi=23h/letr=49h;"I"

;		retlw	H'74'	;poi=24h/letr=4ah;"J"
;		retlw	H'a3'	;poi=25h/letr=4bh;"K"
;		retlw	H'44'	;poi=26h/letr=4ch;"L"

;		retlw	H'c2'	;poi=27h/letr=4dh;"M"
;		retlw	H'82'	;poi=28h/letr=4eh;"N"
;		retlw	H'e3'	;poi=29h/letr=4fh;"O"
	 		
;		retlw	H'64'	;poi=2ah/letr=50h;"P"
;		retlw	H'd4'	;poi=2bh/letr=51h;"Q"
;		retlw	H'43'	;poi=2ch/letr=52h;"R"
			
;		retlw	H'03'	;poi=2dh/letr=53h;"S"
;		retlw	H'81'	;poi=2eh/letr=54h;"T"
;		retlw	H'23'	;poi=2fh/letr=55h;"U"
					
;		retlw	H'14'	;poi=30h/letr=56h;"V"
;		retlw	H'63'	;poi=31h/letr=57h;"W"
;		retlw	H'94'	;poi=32h/letr=58h;"X"
		
;		retlw	H'b4'	;poi=33h/letr=59h;"Y"
;		retlw	H'c4'	;poi=34h/letr=5ah;"Z"
;		retlw	H'b5'	;poi=35h/letr=XX;"KN"
;		retlw	H'15'	;poi=36h/	;"VE"

cq_bun		addwf	PCL,1
		
		retlw	H'a4'		;"C" pos=0
		retlw	H'd4'		;"Q" pos=1
		retlw	H'00'		;"_" pos=2	
		retlw	H'a4'		;"C" pos=3
		retlw	H'd4'		;"Q" pos=4
		retlw	H'00'		;"_" pos=5
		retlw	H'a4'		;"C" pos=6
		retlw	H'd4'		;"Q" pos=7
		retlw	H'00'		;"_" pos=8
		retlw	H'83'		;"D" pos=9
		retlw	H'01'		;"E" pos=10
		retlw	H'00'		;"_" pos=11
		retlw	H'ff'		;END pos=12  0ffh ōŌ𔻒f
		nop

te_bun		addwf	PCL,1
		
		retlw	H'81'		;"T" pos=0
		retlw	H'01'		;"E" pos=1
		retlw	H'03'		;"S" pos=2	
		retlw	H'81'		;"T" pos=3
		retlw	H'00'		;"_" pos=4
		retlw	H'ff'		;END pos=5  0ffh ōŌ𔻒f
		nop

de_bun		addwf	PCL,1
		retlw	H'83'		;"D" pos=0
		retlw	H'01'		;"E" pos=1
		retlw	H'00'		;"_" pos=2
		retlw	H'ff'		;END pos=3  0ffh ōŌ𔻒f
		nop
		
xkp_bun		addwf	PCL,1
		retlw	H'74'		;"J" pos=0;ctm;CusTaMise required!!
		retlw	H'a3'		;"K" pos=1;ctm
		retlw	H'7d'		;"1" pos=2;ctm
		retlw	H'94'		;"X" pos=3;ctm
		retlw	H'a3'		;"K" pos=4;ctm
		retlw	H'64'		;"P" pos=5;ctm
		retlw	H'00'		;"_" pos=6
		retlw	H'ff'		;END pos=7  0ffh ōŌ𔻒f
		nop

k_bun		addwf	PCL,1
		retlw	H'a3'		;"K" pos=0
		retlw	H'ff'		;END pos=1  0ffh ōŌ𔻒f
		nop


HR_bun		addwf	PCL,1
		retlw	H'04'		;"H" pos=0
		retlw	H'43'		;"R" pos=1
		retlw	H'00'		;"_" pos=2
		retlw	H'04'		;"H" pos=3
		retlw	H'43'		;"R" pos=4
		retlw	H'00'		;"_" pos=5
		retlw	H'8d'		;"BT" pos=6
		retlw	H'ff'		;END pos=7  0ffh ōŌ𔻒f
		nop

stamp_bun	addwf	PCL,1
		retlw	H'81'		;"T" pos=0
		retlw	H'82'		;"N" pos=1
		retlw	H'94'		;"X" pos=2
		retlw	H'00'		;"_" pos=3
		retlw	H'24'		;"F" pos=4
		retlw	H'01'		;"E" pos=5
		retlw	H'43'		;"R" pos=6
		retlw	H'00'		;"_" pos=7
		retlw	H'23'		;"U" pos=8
		retlw	H'43'		;"R" pos=9
		retlw	H'00'		;"_" pos=10
		retlw	H'a4'		;"C" pos=11
		retlw	H'42'		;"A" pos=12
		retlw	H'44'		;"L" pos=13
		retlw	H'44'		;"L" pos=14
		retlw	H'00'		;"_" pos=15
		retlw	H'8d'		;"BT" pos=16
		retlw	H'00'		;"_" pos=17
		retlw	H'23'		;"U" pos=18
		retlw	H'43'		;"R" pos=19
		retlw	H'00'		;"_" pos=20
		retlw	H'43'		;"R" pos=21
		retlw	H'03'		;"S" pos=22
		retlw	H'81'		;"T" pos=23
		retlw	H'00'		;"_" pos=24
		retlw	H'43'		;"R" pos=25
		retlw	H'03'		;"S" pos=26
		retlw	H'81'		;"T" pos=27
		retlw	H'00'		;"_" pos=28
		retlw	H'05'		;"5" pos=29
		retlw	H'f5'		;"9" pos=30
		retlw	H'f5'		;"9" pos=31
		retlw	H'00'		;"_" pos=32
		retlw	H'05'		;"5" pos=33
		retlw	H'82'		;"N" pos=34
		retlw	H'82'		;"N" pos=35
		retlw	H'00'		;"_" pos=36
		retlw	H'8d'		;"BT" pos=37
		retlw	H'00'		;"_" pos=38
		retlw	H'04'		;"H" pos=39
		retlw	H'43'		;"R" pos=40
		retlw	H'00'		;"_" pos=41
		retlw	H'd4'		;"Q" pos=42
		retlw	H'81'		;"T" pos=43
		retlw	H'04'		;"H" pos=44
		retlw	H'00'		;"_" pos=45
		retlw	H'd4'		;"Q" pos=46
		retlw	H'81'		;"T" pos=47
		retlw	H'04'		;"H" pos=48
		retlw	H'00'		;"_" pos=49
		retlw	H'b4'		;"Y" pos=50;ctm
		retlw	H'e3'		;"O" pos=51;ctm
		retlw	H'a3'		;"K" pos=52;ctm
		retlw	H'e3'		;"O" pos=53;ctm
		retlw	H'04'		;"H" pos=54;ctm
		retlw	H'42'		;"A" pos=55;ctm
		retlw	H'c2'		;"M" pos=56;ctm
		retlw	H'42'		;"A" pos=57;ctm
		retlw	H'00'		;"_" pos=58
		retlw	H'b4'		;"Y" pos=59;ctm
		retlw	H'e3'		;"O" pos=60;ctm
		retlw	H'a3'		;"K" pos=61;ctm
		retlw	H'e3'		;"O" pos=62;ctm
		retlw	H'04'		;"H" pos=63;ctm
		retlw	H'42'		;"A" pos=64;ctm
		retlw	H'c2'		;"M" pos=65;ctm
		retlw	H'42'		;"A" pos=66;ctm
		retlw	H'00'		;"_" pos=67
		retlw	H'01'		;"E" pos=68
		retlw	H'03'		;"S" pos=69
		retlw	H'00'		;"_" pos=70
		retlw	H'82'		;"N" pos=71
		retlw	H'42'		;"A" pos=72
		retlw	H'c2'		;"M" pos=73
		retlw	H'01'		;"E" pos=74
		retlw	H'00'		;"_" pos=70
		retlw	H'b4'		;"Y" pos=71;ctm
		retlw	H'23'		;"U" pos=72;ctm
		retlw	H'74'		;"J" pos=73;ctm
		retlw	H'02'		;"I" pos=74;ctm
		retlw	H'00'		;"_" pos=75
		retlw	H'b4'		;"Y" pos=76;ctm
		retlw 	H'23'		;"U" pos=77;ctm
		retlw	H'74'		;"J" pos=78;ctm
		retlw	H'02'		;"I" pos=79;ctm
		retlw	H'00'		;"_" pos=82
		retlw	H'04'		;"H" pos=83
		retlw	H'63'		;"W" pos=84
		retlw	H'36'		;"?" pos=85
		retlw	H'00'		;"_" pos=86
		retlw	H'b5'		;"KN" pos=87
		retlw	H'ff'		;END pos=88  0ffh ōŌ𔻒f
		nop
;---------------------------------------------------

beepH	movlw	D'10'	;	mov	cn,#10
		movwf	cn
bpH2	bsf		BZ		;Beep 2400Hz
		nop
		nop
		nop
		nop
		nop
		bcf		BZ		
		nop
		nop
		nop
		nop		
		decfsz	cn,1	;djnz	cn,bpH2
		goto	bpH2
		return

bspace		movlw	D'20'	;	mov	cn,#20
			movwf	cn
bspace0		movlw	D'1'	;mov	wait_cn,#1
			movwf	wait_cn
			call 	wait_us	
			decfsz	cn,1	;	djnz	cn,bspace0
			goto	bspace0
			return
;  ----------------------------------------------
		
;-------------------------------------------
OPmain		return


;------------------------------------------------------
start		call	wait_255		;wait_255  255msec҂

		bsf		STATUS,5	;oN1
	;	;movlw	01011010b	;//RBvAbv,prescaler=S(f pulse=2msec)@
					;^C}[hC	
		movlw	B'00010000'	;//RBvAbv,prescaler=2(f pulse=2msec) 2003.6.24
					;^C}[hC
		movwf	OPTION_REG		;option	
		movlw	B'00010000'	;ra.4-ra.0sOUT !ra,#00000000b	
		movwf	TRISA		;5		;trisA
		movlw	B'11111111'	;rb.0-rb.7sIN  !rb,#11111111b	
		movwf	TRISB		;6		;trisb
		bcf		STATUS,5	;	;oN0
		
		movlw	B'00110000'	;HH	;dash (RB4)=H & dot(RB5)=H
		movwf	memo		;HH
		clrf	opt
		clrf	PORTB
		movlw	B'00001100'			;mov	porta,#00001100b
		movwf	PORTA
		movlw	D'50'				;mov	speed,#50
		movwf	speed

		movlw	B'00000000'		;Bug key auto
		btfss	PORTB,6			;Bug key auto
		movlw	B'10000000'		;Bug key auto //;if Bugauto.7=1, then dash dot auto.
		movwf	Bugauto			;Bug key auto

		movlw	D'150'
		btfss	PORTB,0
		movlw	D'138'
		movwf	timespace

		btfsc	PORTB,0
		goto	s12
s11		btfss	PORTB,0
		goto	s11		

s12		call	xkp		; call sign o
		call	loadopt		;optionload
		call	HHrst	;HH
		
; ---------------------------------
Ekey		clrf	cn		;if cn=250,sleep



ek0		btfsc	PORTB,1
		goto	ek1
		call	STAMP		;;TNX_FER_UR_CALL_BT_UR_RST_RST_599_5NN_ES 
					;;HR_QTH_QTH_YOKOHAMA_YOKOHAMA_ES_NAME_YUJI_YUJI_
					;;HW_?_KN

ek1		btfsc	PORTB,2		;;OPTION_ o
		goto	ek2
		call	OPTN

ek2		btfsc	PORTB,0
		goto	ek3
		call	TEST		;;TEST_ o
		call	xkp		;;JK1XKP_ o


ek3		btfsc	PORTB,3		;if portb,3=L ,call  
		goto	ek4
		bsf		opt,0		;if option쐬Aopt=#0000 0001b 
		call	HR
		movlw	H'20'		;mov	fsr,#20h
		movwf	FSR

ek4		btfsc	PORTB,7
		goto	ek5
		call	CQ		;;CQ_CQ_CQ_DE_ o
		call	xkp		;;JK1XKP_ o
		call	xkp		;;JK1XKP_ o
		call	xkp		;;JK1XKP_ o
		call	K		;;_K o
		
ek5	;	btfsc	PORTB,6
		goto	ek6
	;	call	DEbun		;;DE_ o
	;	call	xkp		;;JK1XKP_ o

ek6
;--------------------
dot0		clrf	sum		;option ݂̐ݒ
		clrf	d8		;option ݂̐ݒ

		btfss	PORTB,5		;if rb.5=L,then dot
		goto	dot

dot01	btfss	PORTB,4		;if rb.4=L,then dash
		goto	dash
dot02	incf	cn,1
		call	space2

dot03	movlw	D'250'		;cje,#250,then   Ekend
		subwf	cn,0	
		btfsc	STATUS,Z
		goto	Ekend
		
dot04		btfss	opt,0		;if not option save, goto ek0
		goto	ek0
		
		movlw	D'14'		;cje,#14,then   opt[]=space;CW_code=0h
		subwf	cn,0	
		btfss	STATUS,Z
		goto	ek0
		
		movlw	H'0'			;mov	d8,#0h
		movwf	d8
		goto	ek9


Ekend	bcf		PORTA,0
		bsf		PORTA,3		;2003.6.24 ȓd͉̂߁@VR+Vdd
		bcf		INTCON,0	;RBIF NA
		bcf		INTCON,1	;INTF NA
		bsf		INTCON,3	;Rb荞݁ARBIEenable
		bsf		INTCON,4	;INT荞݁ARBIEenable

		sleep		;power down mode ȓd
Loop	bcf		INTCON,7	;GIE NA
		btfsc	INTCON,7
		goto	Loop
		bcf		INTCON,3	;Rb荞݁ARBIEdisable
		bcf		INTCON,4	;INT荞݁ARBIEdisable
		bcf		PORTA,3		;2003.6.24

		goto	Ekey				

dot		movlw	B'00110000'	;HH	;dash (RB4)=H & dot(RB5)=H
		movwf	memo		;HH
		nop					;HH 2014.04.20	ǉ
		call	HHcnt		;HH HH1@HH0 //couting dot
		movlw	B'00001111'	;HH continuiouse dot*9
		subwf	HH1,0		;HH
		btfss	STATUS,Z	;HH
		goto	dt1			;HH
		goto	dt2			;HH

dt1		movlw	B'00011111'	;HH continuiouse dot*10
		subwf	HH1,0		;HH
		btfss	STATUS,Z	;HH
		goto	dt3			;HH
		goto	dt2			;HH

dt2		call	space4		;HH
		goto	dt5			;HH

dt3		incf	sum,1		;option ݂̐ݒ
		bcf		STATUS,C		;option ݂̐ݒ
		rlf		d8,1		;option ݂̐ݒ

		call	mark4
	;==@memo reset From here, dot memory==== 	
		movlw	B'00110000'	;HH	;dash (RB4)=H & dot(RB5)=H
		movwf	memo		;HH
	;======================= dot memory==== 

dt5		call	space2
		call	space2

		movlw	B'00000001'	;HH if dot*6, then dot
		subwf	HH1,0		;HH
		btfsc	STATUS,Z	;HH
		goto	dot			;HH

		movlw	B'00000011'	;HH if dot*7, then dot
		subwf	HH1,0		;HH
		btfsc	STATUS,Z	;HH
		goto	dot			;HH

		btfss	memo,4		;HH if RB4=L (memory of dash),goto dash
		goto	dash		;HH

dot_a	btfss	PORTB,4		;if rb.4=L,then dash	
		goto	dash
		btfss	PORTB,5		;if rb.5=L,then dot	
		goto	dot
		
dot1	
		call	space2

		btfss	PORTB,4		;if rb.4=L,then dash	
		goto	dash
		btfss	PORTB,5		;if rb.5=L,then dot	
		goto	dot
		
		call	space4
		call	space2

dotend	call	HHrst		;HH
		btfsc	opt,0
		goto 	ek7
		goto	Ekey

dash	movlw	B'00110000'	;HH	;dash (RB4)=H & dot(RB5)=H
		movwf	memo		;HH
		call	HHrst		;HH
		incf	sum,1		;option ݂̐ݒ
		bsf		STATUS,C	;c		;option ݂̐ݒ
		rlf		d8,1		;option ݂̐ݒ
	
		
		btfsc	PORTB,6		;Bug key
		goto	dash1		;Bug key
	;---
		btfss	Bugauto,7	;;if Bugauto.7=1, then dash dot auto./B1
		goto	B9	
	;---
							;dot=100, space=100, dash=300
B1		clrf	cs			;Bug key-auto	;mark count 1 for 1*mark
		bsf		PORTA,1		;Bug key-auto
		call	Bmark1		;Bug key-auto

		;@Z_;;;;
		movf	cs,1		;Bug key-auto	;if cs=0	(0-25)
		btfsc	STATUS,Z	;Bug key-auto
		goto	B20			;Bug key-auto

		movlw	D'1'		;Bug key-auto	;if cs=1	(25-50)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B21

		movlw	D'2'		;Bug key-auto	;if cs=2	(50-75)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B22

		movlw	D'3'		;Bug key-auto	;if cs=3	(75-100)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B23
		; ܂ŒZ_G

			;;璷_;;
		movlw	D'8'		;Bug key-auto	;if cs=8	(200-225)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B40	

		movlw	D'9'		;Bug key-auto	;if cs=9	(225-250)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B41

		movlw	D'10'		;Bug key-auto	;if cs=10	(250-275)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B42

		movlw	D'11'		;Bug key-auto	;if cs=11	(275-300)
		subwf	cs,0		;Bug key-auto	W=cs +(256-1)
		btfsc	STATUS,Z	;Bug key-auto	if cs=1, goto B2=dot
		goto	B43	
		goto	B6			;Bug key-auto@Other@cs than 0,1,2,3,  8,9,10,11
			;;܂Œ_GG
		;-----
		;-----
B20		call	wtm1		;Bug key-auto	;cs=0 remaining period
		call	mark3		;Bug key-auto	(75)
		goto	B6		;Bug key-auto

B21		call	wtm1		;Bug key-auto	;cs=1 remaining period
		call	mark2		;Bug key-auto	(50)		
		goto	B6		;Bug key-auto	

B22		call	wtm1		;Bug key-auto	;cs=1 remaining period
		call	mark1		;Bug key-auto	(25)
		goto	B6		;Bug key-auto

B23		call	wtm1		;Bug key-auto	;cs=1 remaining period
		goto	B6		;Bug key-auto

B40		call	wtm1		;Bug key-auto	;cs=4 remaining period
		call	mark3		;Bug key-auto	(75)
		goto	B6		;Bug key-auto

B41		call	wtm1		;Bug key-auto	;cs=4 remaining period
		call	mark2		;Bug key-auto	(50)
		goto	B6		;Bug key-auto

B42		call	wtm1		;Bug key-auto	;cs=4 remaining period
		call	mark1		;Bug key-auto	(25)
		goto	B6		;Bug key-auto

B43		call	wtm1		;Bug key-auto	;cs=4 remaining period
		goto	B6		;Bug key-auto

B6		call	space1		;Ȃ(25)
		goto	dash2		;Bug key-auto	;
	;----------------------
B9		bsf		PORTA,1		;Bug key
dashB	movlw	D'1'		;Bug key
		movwf	wait_cn		;Bug key
		call	wtm1		;Bug key
		btfss	PORTB,4		;Bug key
		goto	dashB		;Bug key
		bcf		PORTA,1		;Bug key
		bcf		PORTA,1		;Bug key
		goto	dash2		;Bug key

dash1	call	mark8
	;==@memo reset From here, dot memory==== 	
		movlw	B'00110000'	;HH	;dash (RB4)=H & dot(RB5)=H
		movwf	memo		;HH
	;======================= dot memory==== 
		call	mark2	
		call	mark2

dash2	call	space4		;(100)

		btfss	memo,5		;HH; if RB5=L (memory of dash),goto dash
		goto	dot		;HH
		
		btfss	PORTB,5		;if rb.5=L,then goto dash3 (dot) 
		goto	dash3
		btfss	PORTB,4		;if rb.4=L,then dash 
		goto	dash

		call	HHrst		;HH
		goto	dot_a

dash3	goto	dot

;---------------ȉ option EEPROM ւ̏ 
ek7		movf	sum,0		;sum=cw_codeEZ_\
		andlw	B'00000111'
		movwf	sum		;sum<=7
		sublw	D'8'		;W 8-sum
		movwf	cs		;cs 8-sum
ek8		bcf		STATUS,C	;c
		rlf		d8,1
		decfsz	cs,1			;djnz	cs,ek8
		goto	ek8
		movf	sum,0		;W sum
		xorwf	d8,1		;d8  CW_code	
		movf	d8,0
		
ek9		sublw	H'15'		;if d8="VE"?,then goto ek11
		btfsc	STATUS,Z
		goto	ek11
		
		movlw	H'4f'		;4fh=register ŏIԒn
		subwf	FSR,0
		btfsc	STATUS,Z
		goto	ek11

ek10	movf	d8,0
		movwf	INDF		;indirect 	;opbun[0-48]ɏ
		incf	FSR,1
		goto	Ekey	

ek11	movlw	H'ff'		;0ffh=END ōŌ𔻒f
		movwf	INDF		;indirect	;opbun[Ō] 0ffh
		
		movlw	H'20'
		subwf	FSR,0		;W=fsr(max)-20h
		addlw	D'1'
		movwf	cs		;cs=option̕
		call	save_opt

		bcf		opt,0
		call	dt_5		;saveIɍ} 10_dot
		call	dt_5
		goto	Ekey

;--------------------
space14		call	space6		;if 7*space, then space6+8
space8		call	space2		; space2+6
space6		call	space2		; space2+4
space4		call	space2		; space2+2
space2		call	space1		;if space, then space2
space1		bcf		PORTA,1
			bcf		PORTA,0
			call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check
			movf	speed,0			;mov	wait_cn,speed
			movwf	wait_cn	
			call	wait_sp		;HH;Time='speed 'msec
			return
;-------------------
mark8		call	mark2	
mark6		call	mark2		;if dash, then mark6
mark4		call	mark1		;if dash, then mark4+mark2
mark3		call	mark1
mark2		call	mark1		;if dot, then mark2
mark1		bsf		PORTA,1
			bsf		PORTA,0
		;	call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check
			movf	speed,0		;mov	wait_cn,speed	
			movwf	wait_cn
			call	wait_mk
			return
;-----------------------------
wait_sp		 ;150 * (1+3) *2=1200sec	;HH
			movf	PORTB,0		
			andlw	B'00110000'		
			andwf	memo,1		;memory of dash or dot 

wts1		nop		;800Hz Tone
	;		;movlw	D'150'			;mov	wait_cn2,#250	;-------- --------- 
			movf	timespace,0		;timespace=150 or 138 (Mark:space=100:92) 
			movwf	wait_cn2    
					;	| 	|    
wts2		nop					;1  (1msec)	|
					;	|	|
			decfsz	wait_cn2,1	;1	;djnz	wait_cn2,wtm2	;3------- 	|
			goto	wts2		;2
					;	("speed" msec)
wts3		nop
	;		;movlw	D'150'			;mov	wait_cn2,#250	;-------- ---------
 			movf	timespace,0		;timespace=150 or 138 (Mark:space=100:92) 
			movwf	wait_cn2    
					;	| 	|    
wts4		nop					;1  (1msec)	|
								;	|	|
			decfsz	wait_cn2,1	;1	;djnz	wait_cn2,wtm2	;3------- 	|
			goto	wts4		;2
					;	("speed" msec)
			decfsz	wait_cn,1			;djnz	wait_cn,wtm1   	;	   	|
			goto	wts1
			return			;	  -----------	

;-------------------------
wait_mk		 ;150 * (1+3) *2=1200sec	;HH
			movf	PORTB,0		
			andlw	B'00110000'		
			andwf	memo,1		;memory of dash or dot 

wtm1		movf	wait_cn,1	;Bug key auto TRAP
			btfsc	STATUS,Z
			return

			bsf		PORTA,0		;800Hz Tone
			movlw	D'150'			;;-------- --------- 
			movwf	wait_cn2    
									;;	| 	|    
wtm2		nop						;;1  (1msec)	|
									;;	|	|
			decfsz	wait_cn2,1		;;1	;;3------- 	|
			goto	wtm2			;;2
									;;	("speed" msec)
wtm3		bcf		PORTA,0
			movlw	D'150'			;;-------- --------- 
			movwf	wait_cn2    
									;;	| 	|    
wtm4		nop						;;1  (1msec)	|
									;;	|	|
			decfsz	wait_cn2,1		;;1	;;3------- 	|
			goto	wtm4			;;2
									;;	("speed" msec)
			decfsz	wait_cn,1		;;		;	   	|
			goto	wtm1
			return			;	  -----------	

;======--Bug key auto	wait_mk
Bmark1		bsf		PORTA,0
		;	call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check
			movf	speed,0		;mov	wait_cn,speed	
			movwf	wait_cn
;-------------
Bwait_mk		 ;150 * (1+3) *2=1200sec	;HH
			movf	PORTB,0		
			andlw	B'00110000'		
			andwf	memo,1		;memory of dash or dot 

Bwtm1		bsf		PORTA,0		;800Hz Tone
			movlw	D'150'			;;-------- --------- 
			movwf	wait_cn2    
									;;	| 	|    
Bwtm2		nop						;;1  (1msec)	|
									;;	|	|
			decfsz	wait_cn2,1		;;1	;;3------- 	|
			goto	Bwtm2			;;2
									;;	("speed" msec)
Bwtm3		bcf		PORTA,0
			btfsc	PORTB,4		;if dash key OFF, then reurn
			return

			movlw	D'150'			;;-------- --------- 
			movwf	wait_cn2    
									;;	| 	|    
Bwtm4		nop						;;1  (1msec)	|
									;;	|	|
			decfsz	wait_cn2,1		;;1	;;3------- 	|
			goto	Bwtm4			;;2
		
			btfsc	PORTB,4		;if dash key OFF, then reurn
			return
							;;	("speed" msec)
			decfsz	wait_cn,1		;;		;	   	|
			goto	Bwtm1
			incf	cs,1
			goto	Bmark1	

			;return			;	  -----------
	
;-----------------
spdch			;720usec		
		bcf		INTCON,2	;clr TOIF
		bcf		STATUS,5	;oN0		
		clrf	TMR0		;TMR0NA
		bsf		STATUS,5	;oN1	
		clrwdt		
		movlw	B'00010100'	;ra2  outputinput
		movwf	TRISA	;;PORTA
		bcf		STATUS,5	;oN0	
		
		bcf		PORTA,3		;Rڒn		
spd2	btfsc	INTCON,2	;2 step;---if overflow, goto spd3			
		goto	spd3		;0	|
					;	| 1Loop=5step	
		btfsc	PORTA,2		;1step	|	
		goto	spd2		;2step------
		movf	TMR0,0		;W TRM0
		goto	spd4			
						
spd3	movlw	D'150'	
		
spd4	movwf	speed

		bsf		STATUS,5	;oN1	
		movlw	B'00010000'	;ra2  inputoutput
		movwf	TRISA	;PORTA
		bcf		STATUS,5	;oN0	

	;	bsf	porta,3		;2003.6.24 폜
		bsf		PORTA,2

		return

;--------------------------------------------------
CQ		clrf	pos		;CQ_CQ_CQ_DE_ o
cq1		movf	pos,0
		call	cq_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	cq3

		call	trans
		incf	pos,1
		goto	cq1

cq3		return
;-------------------------------
xkp		clrf	pos		;JK1XKP_ o
xkp1	movf	pos,0
		call	xkp_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	xkp3

		call	trans
		incf	pos,1
		goto	xkp1

xkp3	return

;--------------------------------------------------
K		clrf	pos		;_K o
k1		movf	pos,0
		call	k_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	k3

		call	trans
		incf	pos,1
		goto	k1

k3		return

;--------------------------------------------------
DEbun	clrf	pos		;DE_ o
de1		movf	pos,0
		call	de_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	de3

		call	trans
		incf	pos,1
		goto	de1

de3		return	

;--------------------------------------------------
HR		clrf	pos		;HR_HR_BT o
hr1		movf	pos,0
		call	HR_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	hr3

		call	trans
		incf	pos,1
		goto	hr1

hr3		return	
;--------------------------------------------------
TEST	clrf	pos		;TEST_ o
te1		movf	pos,0
		call	te_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	te3

		call	trans
		incf	pos,1
		goto	te1

te3		return	
;--------------------------------------------------
STAMP	clrf	pos		;o[X^v_o
st1		movf	pos,0
		call	stamp_bun
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	st3

		call	trans
		incf	pos,1
		goto	st1
st3		return

;--------------------------------------------------
OPTN	movlw	H'20'	;mov	fsr,#20h		;option_o
		movwf	FSR
opt1		movf	INDF,0	;indirect,0
		movwf	cwcode

		sublw	H'ff'
		btfsc	STATUS,Z
		goto	opt3

	
		call	trans
		incf	FSR,1
		goto	opt1
opt3	return
;----------------------------------------------------
dt_5	movlw	H'5'	;mov  	code,#05h
		movwf	cwcode
		call	trans
		return	
;----------------------------------------------------

trans		movf	cwcode,0
		andlw	B'00000111'
		movwf	length

		movf	cwcode,0
		andlw	B'11111000'
		movwf	cwcode

		movlw	D'0'			;cse	length,#0
		subwf	length,0
		btfss	STATUS,Z
		goto	trans0
		call	spce28		
		return
trans0	rlf		cwcode,1
		btfsc	STATUS,C
		bsf		mk,0
		btfss	STATUS,C
		bcf		mk,0

		btfsc	mk,0
		call	mrk12
		btfss	mk,0
		call	mrk4
		call    spce4
		decfsz	length,1			;djnz	length,trans0
		goto	trans0
		call	spce12
		return

;-----------------------------------
;spce14		call	spce6		;if 7*space, then space6+8;  2003.6.24 C
;spce8		call	spce2		; space2+6		
;spce6		call	spce2		; space2+4
;spce4		call	spce2		; space2+2
;spce2		call	spce1		;if space, then space2

spce28	call	spce14
spce14	call	spce1		;2003.6.23 C
		call	spce1
		call	spce1
spce12	call	spce1
		call	spce1
		call	spce1
		call	spce1
spce8	call	spce1
		call	spce1
spce6	call	spce1
		call	spce1
spce4	call	spce1
		call	spce1
spce2	call	spce1
spce1	bcf		PORTA,1
		bcf		PORTA,0
		call	spdch		;speed `FbN;R=10k{C=1000pF̎萔check		
		movf	speed,0			;mov	wait_cn,speed
		movwf	wait_cn	
		call	wait_sp2	;Time='speed 'msec
		return
;-------------------
;mrk6		call	mrk2		;if dash, then mark6	;  2003.6.24 C
;mrk4		call	mrk2		;if dash, then mark4+mark2
;mrk2		call	mrk1		;if dot, then mark2

mrk12	call	mrk1
		call	mrk1
		call	mrk1
		call	mrk1
mrk8	call	mrk1
		call	mrk1
mrk6	call	mrk1
		call	mrk1
mrk4	call	mrk1
		call	mrk1
mrk2	call	mrk1
mrk1	bsf		PORTA,1
		bsf		PORTA,0
	;	call	spdch		;speed `FbN;R=10k{C=100pF̎萔check
		movf	speed,0	;	mov	wait_cn,speed
		movwf	wait_cn	
		call	wait_mk2
		return
;-----------------------------
wait_mk2	btfss	opt,0		;option save key肱݂Ȃւ̕B
		goto	wtm20		;key 荞݂̂Pmsec EFCg
		call	wait_mk		;key 荞݂Ȃ̂Pmsec EFCg
		return	

wtm20		     	;75 * (2+2+1+3) *2 =1200 sec
		nop
wtm21	bsf		PORTA,0
		movlw	D'75'	;mov	wait_cn2,#125	;-------- ---------  
		movwf	wait_cn2  
							;	| 	|    
wtm22	btfss	PORTB,4		;2	| 	| key ω?
		return				;0	| 	|
		btfss	PORTB,5		;2	| 	| key ω?
		return				;0	| 	|
		nop					;1  (1msec)	|
							;	|	|
		decfsz	wait_cn2,1	;1	;djnz	,wtm22	;3------- 	|
		goto	wtm22		;2
		nop
wtm23	bcf		PORTA,0
		movlw	D'75'		;-------- ---------  
		movwf	wait_cn2  
							;	| 	|    
wtm24	btfss	PORTB,4		;2	| 	| key ω?
		return				;0	| 	|
		btfss	PORTB,5		;2	| 	| key ω?
		return				;0	| 	|
		nop					;1  (1msec)	|
							;	|	|
		decfsz	wait_cn2,1	;1	;djnz	,wtm22	;3------- 	|
		goto	wtm24		;2
					;	("speed" msec)
		decfsz	wait_cn,1			;djnz	wait_cn,wtm21   	;	   	|
		goto	wtm21
		return	
	;--------------------
wait_sp2	btfss	opt,0		;option save key肱݂Ȃւ̕B
		goto	wts20		;key 荞݂̂Pmsec EFCg
		call	wait_sp		;key 荞݂Ȃ̂Pmsec EFCg
		return	

wts20		     	;75 * (2+2+1+3) *2 =1200 sec
		nop
wts21	nop
		movlw	D'75'	;mov	wait_cn2,#125	;-------- ---------  
		movwf	wait_cn2  
							;	| 	|    
wts22	btfss	PORTB,4		;2	| 	| key ω?
		return				;0	| 	|
		btfss	PORTB,5		;2	| 	| key ω?
		return				;0	| 	|
		nop					;1  (1msec)	|
							;	|	|
		decfsz	wait_cn2,1	;1	;djnz	,wtm22	;3------- 	|
		goto	wts22		;2
		nop
wts23	nop
		movlw	D'75'		;-------- ---------  
		movwf	wait_cn2  
							;	| 	|    
wts24	btfss	PORTB,4		;2	| 	| key ω?
		return				;0	| 	|
		btfss	PORTB,5		;2	| 	| key ω?
		return				;0	| 	|
		nop					;1  (1msec)	|
							;	|	|
		decfsz	wait_cn2,1	;1	;djnz	,wtm22	;3------- 	|
		goto	wts24		;2
					;	("speed" msec)
		decfsz	wait_cn,1			;djnz	wait_cn,wtm21   	;	   	|
		goto	wts21
		return	

;---------------------------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255	movlw	D'255'			;mov	wait_cn,#255
			movwf	wait_cn
			goto	wait_ms

wait_20		movlw	D'20'			;mov	wait_cn,#20
			movwf	wait_cn
wait_ms  
		
wait_ms0
			movlw	D'0'			;mov	wait_cn2,#0
			movwf	wait_cn2
wait_ms1
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		decfsz	wait_cn2,1				;djnz	wait_cn2,wait_ms1
		goto	wait_ms1
		decfsz	wait_cn,1				;djnz	wait_cn,wait_ms0
		goto	wait_ms0
		return

;
;		ʂI[_[̃EFCg
;
wait_us
wait_us0
		decfsz	wait_cn,1			;djnz	wait_cn,wait_us0
		goto	wait_us0
		return

;----------------
		nop
		nop
		nop
;    ------------------------------------
save_opt	movlw	H'0'	;mov	pos,#0h		;EEPROM address 0&h
			movwf	pos
			movlw	H'20'	;mov	fsr,#20h	;opbun[0] resistorw
			movwf	FSR

savert	movf	pos,0	;mov	eeadr,pos
		movwf	EEADR
		movf	INDF,0	;mov	eedata,indirect
		movwf	EEDATA
		call	datawrite
		incf	pos,1
		incf	FSR,1
		decfsz	cs,1			;djnz	cs,savert
		goto	savert
		return

;-----------------------------------------------
loadopt		movlw	H'0'	;mov	pos,#0h			;EEPROM address 0&h
			movwf	pos
			movlw	H'20'	;mov	fsr,#20h		;option resistorw
			movwf	FSR
			movlw	D'48'		;mov	cs,#48
			movwf	cs
		
load_rt		movf	pos,0	;mov	eeadr,pos		;EEPROM address 0&h
			movwf	EEADR
		bsf		STATUS,RP0
		bsf		EECON1,0
		bcf		STATUS,RP0
		movf	EEDATA,0		;mov	indirect,eedata	
		movwf	INDF	
		incf	pos,1
		incf	FSR,1
		decfsz	cs,1		;djnz	cs,load_rt
		goto	load_rt
		return				;2002.9.21
;   ----------------------------------------		

datawrite	clrf	INTCON
		bsf		STATUS,RP0
		bsf		EECON1,2		;WRENޯ on

		movlw	H'55'
		movwf	EECON2
		movlw	H'aa'
		movwf	EECON2

		bsf		EECON1,1		;WRޯď
		bcf		EECON1,4	
		bcf		EECON1,2		;WRENޯ off
		bcf		STATUS,RP0

		movlw	D'15'		;mov	,#15		; wait 15ms
		movwf	wait_cn
		call	wait_ms
		return

HHrst	clrf	HH1				;HH 2014.04.20	ǉ
		movlw	B'00000111'		;HH
		btfss	PORTA,4
		movlw	B'00000000'
		movwf	HH0				;HH
		return					;HH
HHcnt	bsf		STATUS,C
		btfss	PORTA,4
		bcf		STATUS,C		;HH
		rlf		HH0,1			;HH
		rlf		HH1,1			;HH
		return					;HH
        END                       ; directive 'end of program'

